<script setup lang="ts">
import { computed, ref, watch } from 'vue';
import {
  SaveButton,
  UndoButton,
  CloseButton,
  DeleteButton,
} from 'components/button';
import { dialog } from 'stores/utils';

import { useI18n } from 'vue-i18n';
import { VuePDF, usePDF } from '@tato30/vue-pdf';

const { t } = useI18n();
const currentFileSelected = ref<string>('');
const file = defineModel<
  {
    name?: string;
    group?: string;
    url?: string;
    file?: File;
  }[]
>('file', {
  default: [],
});

const currentFile = computed(() => file.value.at(currentIndex.value));
const statusOcr = defineModel<boolean>('statusOcr', { default: false });
const currentMode = ref<string>('');
const currentIndex = ref(0);

const scale = ref(1);
const page = ref(1);

const currentIndexDropdownList = ref(0);

const props = withDefaults(
  defineProps<{
    treeFile: { label: string; file: { label: string }[] }[];
    readonly?: boolean;
    dropdownList?: { label: string; value: string }[];
    hideAction?: boolean;
    branch?: boolean;
  }>(),
  {
    treeFile: () => [],
    branch: false,
  },
);

function browse() {
  inputFile?.click();
}

const inputFile = (() => {
  const _element = document.createElement('input');
  _element.type = 'file';
  _element.accept = 'image/jpeg,image/png';
  _element.addEventListener('change', change);
  return _element;
})();

function change(e: Event) {
  const _element = e.target as HTMLInputElement | null;
  const _file = _element?.files?.[0];
  currentIndex.value = file.value.length;

  if (_file) {
    currentIndex.value = file.value.length + 1;
    const reader = new FileReader();
    reader.readAsDataURL(_file);
    reader.onload = () => {
      if (file.value[currentIndex.value]) {
        file.value[currentIndex.value].url = reader.result as string;
        console.log(file.value[currentIndex.value]);
      }
    };

    if (_file && file.value[currentIndex.value]) {
      file.value[currentIndex.value].file = _file;
      file.value[currentIndex.value].group =
        props.dropdownList?.[currentIndexDropdownList.value].value;
    } else {
      const newName =
        props.dropdownList?.[currentIndexDropdownList.value].value +
        '-' +
        _file.name;

      file.value.push({
        name: props.branch === true ? _file.name : newName,
        group: props.dropdownList?.[currentIndexDropdownList.value].value,
        file: _file,
      });

      currentFileSelected.value = props.branch === true ? _file.name : newName;
    }

    statusOcr.value = true;

    if (props.branch === true) {
      emit(
        'save',
        props.dropdownList?.[currentIndexDropdownList.value].value || '',
        inputFile?.files?.[0],
      );
    } else {
      emit(
        'sendOcr',
        props.dropdownList?.[currentIndexDropdownList.value].value || '',
        inputFile?.files?.[0],
      );
    }
  }
}

watch(currentFileSelected, () => {
  file.value.findIndex((v, i) => {
    if (v.name?.includes(currentFileSelected.value)) {
      currentIndex.value = i;

      const tempValue =
        props.dropdownList?.findIndex((v) =>
          v.value.includes(currentFileSelected.value.split('-')[0]),
        ) || 0;

      currentMode.value = props.dropdownList?.[tempValue].label || 'other';
    }
  });
});

const emit = defineEmits<{
  (e: 'sendOcr', dropdown: string, file?: File): void;
  (e: 'save', group: string, file?: File): void;
  (e: 'deleteFile', filename: string): void;
}>();

const { pdf, pages } = usePDF(computed(() => currentFile.value?.url));

function deleteFileOfBranch(filename: string) {
  dialog({
    color: 'negative',
    icon: 'mdi-alert',
    title: t('dialog.title.confirmDelete'),
    actionText: t('general.delete'),
    persistent: true,
    message: t('dialog.message.confirmDelete'),
    action: async () => {
      emit('deleteFile', filename);
    },

    cancel: () => {},
  });
}

function deleteFile() {
  const tempValue = props.treeFile.find(
    (v: any) => v.label === t(currentMode.value),
  );

  if (!tempValue) return;

  const idx = tempValue.file?.findIndex(
    (v: any) => v.label === currentFileSelected.value,
  );

  dialog({
    color: 'negative',
    icon: 'mdi-alert',
    title: t('dialog.title.confirmDelete'),
    actionText: t('general.delete'),
    persistent: true,
    message: t('dialog.message.confirmDelete'),
    action: async () => {
      emit('deleteFile', currentFileSelected.value);

      currentFileSelected.value = tempValue.file?.[idx - 1].label || '';
    },

    cancel: () => {},
  });
}
</script>

<template>
  <div class="full-width row no-wrap wrapper" style="height: 250px">
    <div class="col full-height column no-wrap">
      <div class="q-pa-sm text-center bordered" style="height: 50px">
        <q-btn-dropdown
          :disable="readonly"
          icon="mdi-upload"
          color="info"
          label="อัปโหลดเอกสาร"
          @click="
            () => {
              if (branch) {
                browse();
              }
            }
          "
        >
          <q-list v-for="(v, i) in dropdownList" :key="v.value">
            <q-item
              clickable
              v-close-popup
              @click="
                () => {
                  currentIndexDropdownList = i;
                  browse();
                }
              "
            >
              <q-item-section>
                <q-item-label>{{ $t(v.label) }}</q-item-label>
              </q-item-section>
            </q-item>
          </q-list>
        </q-btn-dropdown>
      </div>

      <div class="bordered-l bordered-b q-pa-sm col full-height scroll">
        <q-tree
          :nodes="treeFile || []"
          node-key="label"
          label-key="label"
          children-key="file"
          selected-color="primary"
          v-model:selected="currentFileSelected"
          default-expand-all
        >
          <template v-slot:default-header="prop">
            <div class="full-width row items-center justify-between">
              <div class="col-8 ellipsis">
                <q-tooltip>{{ prop.node.label }}</q-tooltip>
                {{ prop.node.label }}
              </div>
              <div v-if="branch">
                <DeleteButton
                  iconOnly
                  @click.stop="
                    () => {
                      deleteFileOfBranch(prop.node.label);
                    }
                  "
                />
              </div>
            </div>
          </template>
        </q-tree>
      </div>
    </div>
    <div v-if="!branch" class="col full-height column no-wrap">
      <div
        class="bordered row items-center justify-evenly q-pa-sm no-wrap"
        style="height: 50px"
      >
        <q-btn
          @click="page = page > 1 ? page - 1 : page"
          class="btn-next"
          icon="mdi-chevron-left"
          unelevated
          dense
          id="btn-prev-page-top"
        />

        <div class="ellipsis">Page {{ page }} of {{ pages }}</div>

        <q-btn
          @click="scale = scale > 0.25 ? scale - 0.25 : scale"
          flat
          dense
          round
          size="12px"
          icon="mdi-magnify-minus-outline"
          class="app-text-dark"
        >
          <q-tooltip>{{ $t('zoomOut') }}</q-tooltip>
        </q-btn>
        <div>{{ scale * 100 }}%</div>

        <q-btn
          flat
          dense
          round
          size="12px"
          class="app-text-dark"
          icon="mdi-magnify-plus-outline"
          @click="scale = scale < 2 ? scale + 0.25 : scale"
        >
          <q-tooltip>{{ $t('general.zoomIn') }}</q-tooltip>
        </q-btn>

        <q-btn
          @click="page = page < pages ? page + 1 : page"
          class="btn-next"
          icon="mdi-chevron-right"
          unelevated
          dense
          id="btn-prev-page-top"
        />
      </div>

      <div
        class="flex flex-center surface-2 bordered-l bordered-r bordered-b full-height scroll"
      >
        <template v-if="statusOcr">
          <q-spinner color="primary" size="3em" :thickness="2" />
        </template>

        <template v-else>
          <VuePDF
            v-if="
              currentFile?.url?.split('?').at(0)?.endsWith('.pdf') ||
              currentFile?.file?.type === 'application/pdf'
            "
            class="q-py-md"
            :pdf="pdf"
            :page="page"
            :scale="scale"
          />

          <q-img v-else class="q-py-md full-width" :src="currentFile?.url" />
        </template>
      </div>
    </div>

    <div v-if="!branch" class="col-5 full-height column no-wrap">
      <div
        class="bordered row items-center justify-between q-pa-sm"
        style="height: 50px"
      >
        {{ currentMode && $t(currentMode) }}
        <div class="row" v-if="!hideAction">
          <UndoButton icon-only type="button" />
          <SaveButton
            icon-only
            type="button"
            @click="
              $emit(
                'save',
                dropdownList?.[currentIndexDropdownList].value || '',
                inputFile?.files?.[0],
              )
            "
          />
        </div>
      </div>

      <div class="q-pa-sm bordered-r bordered-b full-height col scroll">
        <slot name="form" :mode="currentMode.split('.').at(-1)" />

        <div class="row items-center">
          {{ currentFileSelected }}
          <CloseButton
            icon-only
            v-if="!readonly && !!currentFileSelected"
            type="button"
            class="q-ml-sm"
            @click="
              () => {
                deleteFile();
              }
            "
          />
        </div>
      </div>
    </div>

    <div
      v-if="branch"
      class="bordered col-8 surface-2 column justify-center items-center no-wrap scroll"
    >
      <VuePDF
        style="height: 100%"
        v-if="
          currentFile?.url?.split('?').at(0)?.endsWith('.pdf') ||
          currentFile?.file?.type === 'application/pdf'
        "
        class="q-py-md"
        :pdf="pdf"
        :page="page"
        :scale="scale"
      />

      <q-img
        v-else
        class="q-py-md full-width"
        style="height: 220px; max-width: 300px"
        :src="currentFile?.url"
      />
    </div>
  </div>
</template>

<style lang="scss">
.wrapper > * {
  height: 300px;
}
</style>
